//In the Shogakukan continuity a transformation could be acheived with a single emerald
//As such, I've decided to give Nicky a tiered equivalent to the super form
//Most of this is based on the Superform implimentation in the source code, converted into Lua
freeslot(
"S_PLAY_EMPOWER1",
"S_PLAY_EMPOWER2",
"S_PLAY_EMPOWER3",
"S_PLAY_EMPOWER4",
"S_PLAY_EMPOWER5",
"S_PLAY_EMPOWER6"
)

states[S_PLAY_EMPOWER1] = {SPR_PLAY, SPR2_TRNS|FF_ANIMATE, 	   7, nil, 0, 4, S_PLAY_EMPOWER2}
states[S_PLAY_EMPOWER2] = {SPR_PLAY, SPR2_TRNS, 			   3, nil, 0, 0, S_PLAY_EMPOWER3}
states[S_PLAY_EMPOWER3] = {SPR_PLAY, SPR2_TRNS|FF_FULLBRIGHT,  2, nil, 0, 0, S_PLAY_EMPOWER4}
states[S_PLAY_EMPOWER4] = {SPR_PLAY, SPR2_TRNS|FF_FULLBRIGHT,  2, nil, 0, 0, S_PLAY_EMPOWER5}
states[S_PLAY_EMPOWER5] = {SPR_PLAY, SPR2_TRNS|FF_FULLBRIGHT,  2, nil, 0, 0, S_PLAY_EMPOWER6}
states[S_PLAY_EMPOWER6] = {SPR_PLAY, SPR2_TRNS|FF_FULLBRIGHT, 19, A_FadeOverlay, 0, 0, S_PLAY_FALL}

local EmpowerBrown = {
SKINCOLOR_NICKYFLASH5,
SKINCOLOR_VAPOR,
SKINCOLOR_PURPLE,
SKINCOLOR_PLUM,
SKINCOLOR_PLUM
}

local EmpowerRed = {
SKINCOLOR_RED,
SKINCOLOR_FLAME,
SKINCOLOR_ORANGE,
SKINCOLOR_BROWN,
SKINCOLOR_BRONZE
}

local function GetEmpowerColor(player, i)
	local sc = player.skincolor
	if (gametyperules&GTR_TEAMS) and player.ctfteam == 1 then 
		return EmpowerRed[i+1]
	elseif (sc == SKINCOLOR_BRONZE) or (sc == SKINCOLOR_BROWN) or (sc == SKINCOLOR_RUST) then
		return EmpowerBrown[i+1]
	else 
		return (SKINCOLOR_NICKYFLASH1 + i)
	end
end

local function Halt(player)
	player.mo.momx = 0
	player.mo.momy = 0
	player.mo.momz = 0
	player.cmomx = 0
	player.cmomy = 0
	player.rmomx = 0
	player.rmomy = 0
end

local function EmpowerMusic(player)
	if player.empower
	and player.playerstate == PST_LIVE
	and not (player.powers[pw_extralife])
	and not (player.pflags & PF_FINISHED)
	and not (player.lives == 0)
	and not (player.powers[pw_underwater] <= 385 and player.powers[pw_underwater] > 0) then
		S_ChangeMusic("NICEMP", true, player)
	end
end

local function EmpowerReady(player)
	if ((player.mo.skin == "nicky")//Currently only Nicky is using this
	and player.empable
	and not player.empower
	and not player.powers[pw_tailsfly]
	and (player.pflags & PF_JUMPED)
	and not (player.powers[pw_shield] & SH_NOSTACK)
	and not (maptol & TOL_NIGHTS)
	and (player.emercount)
	and not P_SuperReady(player)
	and (player.rings >= 50)) then
		return true
	end
	return false
end

local function DoEmpower(player, giverings)
	player.empower = 1
	Halt(player)
	// Transformation animation
	player.mo.state = S_PLAY_EMPOWER1 
	//giverings
	if (giverings and (player.rings < 50))
		player.rings = 50;
	end
	return true
end

local function UnEmpower(player)
	player.empower = 0
	P_SpawnGhostMobj(player.mo)
	if ((player.powers[pw_shield] & SH_STACK) == SH_FIREFLOWER)then
		player.mo.color = SKINCOLOR_WHITE
		G_GhostAddColor(GHC_FIREFLOWER)
	else
		player.mo.color = player.skincolor
	end
	local temp = skins[player.skin].normalspeed
	if player.isxmomentum then player.fakenormalspeed = temp
	else player.normalspeed = temp end
	P_RestoreMusic(player)

	// If you had a shield, restore its visual significance. (never used right now, may update later)
	P_SpawnShieldOrb(player)
end

local function EmpowerStuff(player)
	if not player.mo.valid return end
/*	if player.mo.clrzd then //a version based on timed flashes
		if (player.mo.clrzd % 2) then player.mo.colorized = not $ end
		if player.mo.colorized then player.mo.color = SKINCOLOR_WHITE
		else player.mo.color = player.skincolor end
		player.mo.clrzd = ($+1)%4
	end/**/
	if not player.empower then
		return
	elseif not player.mo.skin == "nicky" then 
		UnEmpower(player)
		return
	end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) then
		return // NiGHTS Super doesn't mix with normal super
	elseif (player.empower > 0) then
		if (not multiplayer) and player.emercount==7 then 
			player.powers[pw_invulnerability] = max($, 2) 
		end
		EmpowerMusic(player)
		local temp = (FixedInt(skins[player.skin].normalspeed)+player.emercount)*FRACUNIT
		if player.isxmomentum then player.fakenormalspeed = temp
		else player.normalspeed = temp end
		if (player.mo.state >= S_PLAY_EMPOWER1) and (player.mo.state < S_PLAY_EMPOWER6) then 		
			Halt(player) 
			return 
		end
		local flash = abs(abs(((3 * player.empower >> 3) % 8) - 4) - 4)
		//player.mo.color = player.empcol + flash
		player.mo.color = GetEmpowerColor(player, flash)
		if (player.mo.state == S_PLAY_EMPOWER6) then // stop here for now
			Halt(player)
			return
		end
		player.empower = $+1
		// Deplete rings over time while empowered
		local e = 5 * max(1, min(player.emercount, 7))
		if (((leveltime % e) == 0) and not (player.exiting)) then
			player.rings = max(0, $ - 1)
			//player.mo.clrzd = 1
		end
		// Ran out of rings!
		if (player.rings <= 0 or player.exiting) then
			player.empower = -1
		end
	end
	if player.empower < 0 then
		UnEmpower(player)
	end
end

addHook("JumpSpinSpecial", function(player)
	if EmpowerReady(player) then return DoEmpower(player) 
	elseif player.empower > 20 then return UnEmpower(player) end
end)

addHook("PlayerThink", EmpowerStuff)