freeslot("sfx_uncurl")
local timervar = 5
local function BitCounter(var)
	local count = 0
	local i = var
	while (i) do
		count = $ + (i & 1)
		i = $ >> 1
	end
	return count
end

local function AngleRand(input)
	local temp = 2*((6 - min(6,input))*FRACUNIT)/(5 +(2*input))
	temp = FixedAngle(temp)
	if P_RandomChance(FRACUNIT/2) then temp = InvAngle(temp) end
	return temp
end	

local function EmeraldCount(player)
	local var = 0
	if player and (gametyperules&GTR_POWERSTONES) then
		var = player.powers[pw_emeralds]
		player.empable = true //TODO: let the server admin set this for all players
	elseif player and ((gametyperules&GTR_CAMPAIGN) or not multiplayer) then
		var = emeralds
		player.empable = true //TODO: let the server admin set this for all players
	elseif player then
		player.empable = false //TODO: let the server admin set this for all players 
		return 2
	else 
		return 0
	end
	if not player.empable then var = 6 end
	return BitCounter(var)
end

local function TumbleDash(player)//Tumbledash handling code adapted from drop dash code
	if player.mo.tumble == nil then
		player.mo.tumble = 0//tumble inactive
		player.mo.prevmomz = 0
		player.prevanim = player.panim
		player.contrtimer = 0 //stasis was interfering with the respin so i'm using this instead of pw_nocontrol
	end
	local mo = player.mo
	if mo.tumble == 1 and P_IsObjectOnGround(mo) and mo.state == S_PLAY_ROLL then
		player.drawangle = $ + AngleRand(player.emercount)
		P_InstaThrust(player.mo, player.drawangle, FixedHypot(player.rmomx,player.rmomy))
	elseif (mo.eflags & MFE_JUSTHITFLOOR)
	and ((player.prevanim == PA_ROLL) or (mo.spinjump and (player.prevanim == PA_JUMP))) 
	and not mo.tumble then //a tic-perfect sweetspot to jump.
		player.mo.spinjump = false
		player.mo.tumble = 2//tumble start
		player.mo.state = S_PLAY_SPINDASH
		player.pflags = $1|PF_STARTDASH
		player.contrtimer = 0 
	elseif mo.tumble == 2 and P_IsObjectOnGround(mo) then 
		S_StartSound(mo, sfx_zoom, player)
		local speed = abs(mo.prevmomz/2)+FixedHypot(player.rmomx,player.rmomy)
		local actionspd = player.actionspd
		if (player.powers[pw_super] or player.empower) then 
			actionspd = $*3/2 
		end
		player.contrtimer = 5 * (10 - player.emercount)
		if (mo.eflags&MFE_UNDERWATER) then actionspd = $*2/3 end
		local spdsum = actionspd + speed
		local thrustint = (((1+player.emercount)*spdsum/14) + spdsum)/3    
		P_InstaThrust(player.mo, player.cmd.angleturn<<16, thrustint)
		player.mo.tumble = 1//tumble active
		player.mo.state = S_PLAY_ROLL
		player.pflags = $1|PF_SPINNING
	elseif mo.tumble == 2 
	or not mo.state == S_PLAY_ROLL then
		player.mo.tumble = 0
	end
	player.mo.prevmomz = mo.momz
	player.prevanim = player.panim
end

addHook("PreThinkFrame", function()
	for player in players.iterate() do
		if player.mo.skin == "nicky" then
			player.qspd = abs(player.mo.momz/2)+FixedHypot(player.rmomx,player.rmomy)
			player.emercount = EmeraldCount(player)
			if player.contrtimer then
				player.cmd.forwardmove = 0
				player.cmd.sidemove = 0
				player.cmd.angleturn = player.drawangle>>16 //yeah this works. now strafe doesn't break tumbledash
				player.cmd.buttons = $ & ~(BT_ATTACK|BT_USE|BT_TOSSFLAG|BT_JUMP|BT_FIRENORMAL)
			elseif player.mo.tumble == 1
				player.mo.tumble = 0
			end
			//if (player.powers[pw_super] or player.empower) then
			//	return
			//end
		end
	end
end)
addHook("MobjMoveBlocked", function(mobj, thing, line)
	local player = mobj.player
	if mobj.skin == "nicky" 
		if (player.powers[pw_super] or player.empower) then
			return
		elseif line and (mobj.player.contrtimer
		or ((player.empable and (player.emercount<2)) and (mobj.state == S_PLAY_ROLL or (mobj.spinjump and mobj.state == S_PLAY_JUMP)))) then
			local f = player.powers[pw_flashing]
			P_DoPlayerPain(player)
			player.powers[pw_flashing] = f
			mobj.tumble = 0
		end
	end
end, MT_PLAYER)	

//Spin and curl toggling code below
local function SpinjumpOn(player)
	player.charflags = $ &~SF_NOJUMPSPIN
	player.pflags = $ &~PF_NOJUMPDAMAGE
	player.mo.spinjump = true
end
local function SpinjumpOff(player)
	player.charflags = $ |SF_NOJUMPSPIN
	player.pflags = $ |PF_NOJUMPDAMAGE
	player.mo.spinjump = false
end
local function SpinjumpCheck(player)
	if player.mo and player.mo.valid and player.mo.skin == "nicky" //and player.mo.nickymode
	and player.pflags & PF_STARTJUMP then
		if (player.pflags & PF_SPINNING) then //if Nicky is spinning, he'll jump like Sonic
			SpinjumpOn(player)
		else								//otherwise, he'll jump like Amy and Fang
			SpinjumpOff(player)
		end
	end
end

local function CurlToggle(player)
	if player.mo and player.mo.valid and player.mo.skin == "nicky" then 
		local mo = player.mo
		local bt = player.cmd.buttons
		local butts = ((bt & BT_CUSTOM1) or (bt & BT_CUSTOM2) or (bt & BT_CUSTOM3) or (bt & BT_FIRENORMAL))
		if (player.pflags & PF_JUMPED) and not player.abilitimer
		//and (mo.spinjump or not butts) then
			player.abilitimer = 5 * (8 - player.emercount) //set ability timer
			player.pflags = $ &~PF_JUMPED //disable jump flag so nojumpspin and nojumpdamage can be retriggered
			if (mo.momz > 0)
				mo.state = S_PLAY_SPRING //transition state is spring if rising
			else
				mo.state = S_PLAY_FALL //or fall otherwise
			end
			if mo.spinjump then
				SpinjumpOff(player)
				S_StartSound(mo,sfx_uncurl)
				S_StopSoundByID(mo,sfx_spin)
			else
				SpinjumpOn(player)
				S_StartSound(mo,sfx_spin)
				S_StopSoundByID(mo,sfx_uncurl)
			end
			player.mo.state = S_PLAY_JUMP //retrigger jump state
			player.pflags = $ |PF_JUMPED //and just to make sure the flag is set
		//	player.pflags = $ &~PF_THOKKED 
		//elseif not mo.spinjump and not (player.pflags & PF_THOKKED) then
		//	player.pflags = $|PF_THOKKED
		//	player.pflags = $ &~PF_JUMPED
		//	P_DoJump(player, true)
		end
		return true
	end
end

//Timer code below
local function IterateTimer(player)
	if player.abilitimer then 
		player.abilitimer = max(0, $ - 1) end
	if player.contrtimer then 
		player.contrtimer = max(0, $ - 1) end
	if player.kicktimer then 
		player.kicktimer = max(0, $ - 1) end
end
local function ResetTimer(player, skipcheck)
	if skipcheck
	or player.powers[pw_justsprung]
	or player.panim == PA_IDLE
	or (player.mo.eflags & MFE_JUSTHITFLOOR and not player.mo.tumble) 		
	then
		player.abilitimer = 0
		player.contrtimer = 0
	end
end
addHook("MobjDamage", function(target, p, p)
    if p and p.skin == "nicky" then
		ResetTimer(p.player, 1)
		p.player.pflags = $ &~PF_THOKKED
		if p.spinjump
			CurlToggle(p.player)
			ResetTimer(p.player, 1)
		end
	end
end)
addHook("PostThinkFrame", function()
	for player in players.iterate() do
		if player.mo.skin == "nicky" then
			if (player.powers[pw_super] or player.empower) then
				if player.abilitimer then player.abilitimer = min($, 5) end
				if player.contrtimer then player.contrtimer = min($, 15) end
			end
			IterateTimer(player)
			ResetTimer(player, 0)
		end
	end
end)

//hooks
addHook("PlayerThink", TumbleDash)		
addHook("JumpSpecial", SpinjumpCheck)
addHook("AbilitySpecial", CurlToggle)